=== debian/changelog ===
calligra (1:2.5.90-0ubuntu2) raring; urgency=low

  * Only build with openimageio on x86 archs as it's not available on the rest 

 -- Philip Muškovac <yofel@kubuntu.org>  Wed, 31 Oct 2012 09:48:23 +0100

calligra (1:2.5.90-0ubuntu1) raring; urgency=low

  * New upstream alpha release (LP: #1070436)
    - Add libkactivities-dev and libopenimageio-dev to build-depends
    - Add kubuntu_build_calligraactive.diff to build calligraactive by default
    - Add package for calligraauthor and move files that are shared between
      calligrawords and calligraauthor to calligrawords-common
  * Document the patches
  * Remove numbers from patches so they follow the same naming scheme as
    the rest of our patches.
  * calligra-data breaks replaces krita-data (<< 1:2.5.3) (LP: #1071686)

 -- Philip Muškovac <yofel@kubuntu.org>  Tue, 23 Oct 2012 21:09:16 +0200
